/* FileBrowser.java created by Administrator on Wed 29-Aug-2001 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.webobjects.*;
import java.io.*;
import java.util.*;


public class FileBrowser extends WOComponent {

    String startingPath;  // passed in
    String callbackUpdateAction;  // passed in
    String callbackSelectionAction;  // passed in
    String filter;

    File aFile;
    NSArray _fileList = null;

    public NSArray fileList() {
        SuffixFileFilter fileFilter = null;
        if (filter != null) {
            fileFilter = new SuffixFileFilter(filter);
        }
        if (_fileList == null) {
            if (startingPath == null || startingPath.equals(""))
                startingPath = "/";
            File dir = new File(startingPath);
            try {
                _fileList = new NSArray(dir.list(fileFilter));
            } catch (Exception e) {
                logString("Can't get file list: " + e.getMessage());
                _fileList = new NSArray(startingPath);
            }
//            debugString("fileList: " + startingPath + " " + _fileList);
        }
        return _fileList;
    }

    public String aCurrentFile() {
        if (aFile == null) aFile = new File(startingPath);
        return aFile.getPath();
    }

    public void setACurrentFile(String value) {
        aFile = new File(NSPathUtilities.stringByAppendingPathComponent(startingPath, value));
    }

    public String replace(String text, String a, String b) {
        NSArray bits = NSArray.componentsSeparatedByString(text, a);
        return bits.componentsJoinedByString(b);
    }

    public WOComponent backClicked() {
//        String aString1 = "/" + startingPath;
        String aString1 = startingPath;
        String aString2 = NSPathUtilities.stringByDeletingLastPathComponent(aString1);
        String aString3 = replace(aString2, "\\", "/");
        if (aString3.equals("")) {
            startingPath = "/";
        } else {
            startingPath = aString3;
        }
        _fileList = null;
//        debugString("back: " + startingPath);
        return (WOComponent)performParentAction(callbackUpdateAction);
    }

    public WOComponent directoryClicked() {
        startingPath = replace(aFile.getPath(), "\\", "/");
        _fileList = null;
//        debugString("dir: " + startingPath);
        return (WOComponent)performParentAction(callbackUpdateAction);
    }

    public WOComponent selectClicked() {
        startingPath = replace(aFile.getPath(), "\\", "/");
//        debugString("select: " + startingPath);
        return (WOComponent)performParentAction(callbackSelectionAction);
    }

    public WOComponent selectCurrentDirClicked() {
        startingPath = replace(startingPath, "\\", "/");
//        debugString("selectCurrentDir: " + startingPath);
        return (WOComponent)performParentAction(callbackSelectionAction);
    }

    public int fileLength() {
        if (aFile == null) aFile = new File(startingPath);
        return (int)aFile.length();
    }

    public NSGregorianDate fileDate() {
        if (aFile == null) aFile = new File(startingPath);
        int y, m, d;
        Date filedate = new Date(aFile.lastModified());
        GregorianCalendar cal = new GregorianCalendar();
        cal.setTime(filedate);
        y = cal.get(Calendar.YEAR);
        m = cal.get(Calendar.MONTH);
        d = cal.get(Calendar.DAY_OF_MONTH);
        NSGregorianDate aDate = new NSGregorianDate(y, m, d, 0, 0, 0, null);
        return aDate;
    }
    
}
