/* RIKey.java created by Administrator on Thu 20-Sep-2001 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;


public abstract class RIKey extends Object {

    protected EOEntity entity;
    protected EOEditingContext ec;
    protected NSArray zeros, nulls;

    public abstract NSArray keys();
    public abstract String key();

    public EOEntity entity() {
        return entity;
    }
    public void setEntity(EOEntity value) {
        entity = value;
/*        debugString("Entity: " + entity);
        debugString("PKs: " + entity.primaryKeyAttributeNames());
        debugString("Relationships: " + entity.relationships());
        debugString("Attributes: " + entity.attributes()); */
    }

    public EOEditingContext ec() {
        return ec;
    }
    public void setEc(EOEditingContext value) {
        ec = value;
    }

    public String modelName() {
        return entity().model().name();
    }

    public String table() {
        return entity().externalName();
    }

    public NSArray zeros() {
        return zeros;
    }

    public NSArray nulls() {
        return nulls;
    }

    public boolean checkIntegrity() {
        zeros = null;
        nulls = null;

        int result = 0;
        result += checkForZero();
        if (result > 0) return true;
        return false;
    }

    public int checkForZero() {
        if (zeros == null) {
            // select count(*) from Table where Key = null or Key = 0
            String sqlString = "select " + key() + " from " + table() + " where " + key() + " = 0";
            System.err.println("SQL: " + sqlString);
            zeros = EOUtilities.rawRowsForSQL(ec, modelName(), sqlString);
        }
        System.err.println("Zero: " + zeros);
        return zeros.count();
    }

    public int checkForNull() {
        if (nulls == null) {
            // doesn't seem to work...
            // select count(*) from Table where Key = null or Key = 0
            String sqlString = "select " + key() + " from " + table() + " where " + key() + " = null";
            System.err.println("SQL: " + sqlString);
            nulls = EOUtilities.rawRowsForSQL(ec, modelName(), sqlString);
        }
        System.err.println("Null: " + nulls);
        return nulls.count();
    }

}
