/* RIPrimaryKey.java created by Administrator on Thu 20-Sep-2001 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;
import java.util.*;


public class RIPrimaryKey extends RIKey {

    protected NSArray dupes;

    public RIPrimaryKey(EOEntity value) {
        setEntity(value);
        ec = new EOEditingContext();
    }
    
    public RIPrimaryKey() {
        ec = new EOEditingContext();
    }

    public NSArray keys() {
        NSMutableArray attributeNames = new NSMutableArray();
        Enumeration i = entity.primaryKeyAttributes().objectEnumerator();
        while (i.hasMoreElements()) {
            EOAttribute a = (EOAttribute)i.nextElement();
            attributeNames.addObject(a.columnName());
        }
        return new NSArray(attributeNames);
    }

    public String key() {
        return keys().componentsJoinedByString(",");
    }

    public NSArray dupes() {
        return dupes;
    }

    public boolean checkIntegrity() {
        dupes = null;

        System.err.println("primary key: " + key());
        int result = 0;
        result += checkForDupes();
        if (result > 0) return true;
        return super.checkIntegrity();
    }

    public int checkForDupes() {
        // select Key, count(*) from Table group by Key having count(*) > 1
        String sqlString = "select " + key() + ", count(*) from " + table() + " group by " + key() + " having count(*) > 1";
        System.err.println("SQL: " + sqlString);
        dupes = EOUtilities.rawRowsForSQL(ec, modelName(), sqlString);
        System.err.println("Dupes: " + dupes);
        return dupes.count();
    }

}
