/* RIRelationship.java created by Administrator on Thu 20-Sep-2001 */

import com.apple.yellow.foundation.*;
import com.apple.yellow.eocontrol.*;
import com.apple.yellow.eoaccess.*;
import com.apple.yellow.webobjects.*;
import java.util.*;


public class RIRelationship extends RIKey {

    protected EORelationship relationship;
    protected NSArray missing;

    public static NSArray initWithRelationships(NSArray relationships) {
        NSMutableArray a = new NSMutableArray();
        if (relationships != null) {
            Enumeration i = relationships.objectEnumerator();
            while (i.hasMoreElements()) {
                EORelationship r = (EORelationship)i.nextElement();
                a.addObject(new RIRelationship(r));
            }
        }
        return new NSArray(a);
    }
    
    public RIRelationship(EORelationship value) {
        setRelationship(value);
        ec = new EOEditingContext();
    }
    
    public RIRelationship() {
        ec = new EOEditingContext();
    }

    public EORelationship relationship() {
        return relationship;
    }
    public void setRelationship(EORelationship value) {
        relationship = value;
        setEntity(relationship.entity());
    }

    public NSArray keys() {
        NSMutableArray attributeNames = new NSMutableArray();
        Enumeration i = relationship.sourceAttributes().objectEnumerator();
        while (i.hasMoreElements()) {
            EOAttribute a = (EOAttribute)i.nextElement();
            attributeNames.addObject(a.columnName());
        }
        return new NSArray(attributeNames);
    }

    public String key() {
        return (String)keys().objectAtIndex(0);
    }

    public NSArray missing() {
        return missing;
    }

    public boolean checkIntegrity() {
        missing = null;
        
        if (relationship.isFlattened()) {
            System.out.println("Skip flattened");
            return false;
        }
        System.err.println("foreign key: " + ((EOAttribute)relationship.destinationAttributes().objectAtIndex(0)).columnName() + " " + ((EOAttribute)relationship.sourceAttributes().objectAtIndex(0)).columnName());
        // needs to skip if isFlattened, and check for null if isMandatory
        int result = 0;
        if (relationship.isMandatory())
            result += checkForNull();
        if (result > 0) return true;
        return super.checkIntegrity();
    }

    public int checkForMissing() {
        if (missing == null) {
        // select count(*) from table where fKey not in (select key from fTable)
            String sqlString = "select " + ((EOAttribute)relationship.destinationAttributes().objectAtIndex(0)).columnName() + " from " + table() + " where " + ((EOAttribute)relationship.destinationAttributes().objectAtIndex(0)).columnName() + " not in (select " + key() + " from " + relationship.destinationEntity().name() + ")";
        System.err.println("SQL: " + sqlString);
        missing = EOUtilities.rawRowsForSQL(ec, modelName(), sqlString);
    }
        System.err.println("Missing: " + missing);
        return missing.count();
    }
}
